#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define str string
#define ldb long double
#define ll long long
#define db double
#define ull unsigned long long
#define ss second
#define ff first
#define pob pop_back
#define pub push_back
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define all(v) v.begin(), v.end()
const ll INF18 = 2e18;
const int INF9 = 2e9;
const db PI = acos(-1);
const db EPS = 1e-5;
mt19937 rnd(time(0));
template <typename T, typename TT>
ostream& operator<<(ostream& out, pair<T, TT> &a) {
    out << "{" << a.ff << ' ' << a.ss << '\n';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, set<T> &a) {
    for (auto it : a)
        out << it << ' ';
    return out;
}
#define print(...) cout << #__VA_ARGS__ << " = " << __VA_ARGS__ << '\n'
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define int ll

signed main() {
    fast

    int n;
    cin >> n;

    vector<int> a(n);

    map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        cnt[a[i]]++;
    }

    vector<vector<int>> cntid(n + 1);
    for (auto it : cnt) {
        cntid[it.ss].pub(it.ff);
    }

    int k = (1 << __lg(n));
    int cur = k / 2;
    bool flag = true;
    vector<int> ans(k, 0); int filled = 0;
    for (int i = 1; filled != k && i <= n; i++) {
        int sz = cntid[i].size();
        if (cur == 0 && sz == 1 || cur && sz == cur) {
            int j = 0;
            while (j < k && ans[j])
                j++;
            bool last = (cur == 0 && sz == 1);
            if (!last) {
                for (auto num : cntid[i]) {
                    ans[j] = num;
                    j += (1 << i);
                    filled++;
                }
            } else {
                ans[j] = cntid[i][0];
                filled++;
                break;
            }
            cur /= 2;
        } else {
            flag = false;
            break;
        }
    }

    if (flag && filled == k) {
        cout << ans;
    } else {
        cout << -1;
    }
    return 0;
}
